Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.autoscaling.model
Class CreateOrUpdateScalingTriggerRequest

    java.lang.Object
      com.amazonaws.AmazonWebServiceRequest
          com.amazonaws.services.autoscaling.model.CreateOrUpdateScalingTriggerRequest

    public class CreateOrUpdateScalingTriggerRequest

extends AmazonWebServiceRequest

Container for the parameters to the `CreateOrUpdateScalingTrigger operation`.

Sets the parameters that govern how and when to scale an AutoScaling group.

See Also:
  `AmazonAutoScaling.createOrUpdateScalingTrigger(CreateOrUpdateScalingTriggerRequest)`

Constructor Summary
`CreateOrUpdateScalingTriggerRequest()`

Method Summary
`String` | `getAutoScalingGroupName()` The name of the AutoScalingGroup to be associated with the trigger.
`Integer` | `getBreachDuration()` The amount of time, in seconds, used to evaluate and determine if a breach is occurring.
`String` | `getCustomUnit()` The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.
`List<Dimension>` | `getDimensions()` A list of dimensions associated with the metric used by the trigger to determine whether to fire.
`String` | `getLowerBreachScaleIncrement()` The incremental amount to use when performing scaling activities after the lower threshold has been breached.
`Double` | `getLowerThreshold()` The lower limit for the metric.
`String` | `getMeasureName()` The measure name associated with the metric used by the trigger to determine when to fire.
`String` | `getNamespace()` Constraints: Length: 1 - 100 Pattern: [ -9;-??-??-?\r\n\t]*
`Integer` | `getPeriod()` The period, in seconds, associated witht he metric statistics.
`String` | `getStatistic()` The statistic that the trigger when fetching metrics to examine.
`String` | `getTriggerName()` The name for the trigger.
`String` | `getUnit()` Constraints: Pattern: (Seconds|Bytes|Bits|Percent|Count|Bytes/Second|Bits/Second|Count/Second|None)
`String` | `getUpperBreachScaleIncrement()` The incremental amount to use when performing scaling activities after the upper threshold has been breached.
`Double` | `getUpperThreshold()` The upper limit for the metric.
`void` | `setAutoScalingGroupName(String autoScalingGroupName)` The name of the AutoScalingGroup to be associated with the trigger.
`void` | `setBreachDuration(Integer breachDuration)` The amount of time, in seconds, used to evaluate and determine if a breach is occurring.
`void` | `setCustomUnit(String customUnit)` The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.
`void` | `setDimensions(Collection<Dimension> dimensions)` A list of dimensions associated with the metric used by the trigger to determine whether to fire.
`void` | `setLowerBreachScaleIncrement(String lowerBreachScaleIncrement)` The incremental amount to use when performing scaling activities after the lower threshold has been breached.
`void` | `setLowerThreshold(Double lowerThreshold)` The lower limit for the metric.
`void` | `setMeasureName(String measureName)` The measure name associated with the metric used by the trigger to determine when to fire.
`void` | `setNamespace(String namespace)` Constraints: Length: 1 - 100 Pattern: [ -9;-??-??-?\r\n\t]*
`void` | `setPeriod(Integer period)` The period, in seconds, associated witht he metric statistics.
`void` | `setStatistic(String statistic)` The statistic that the trigger when fetching metrics to examine.
`void` | `setTriggerName(String triggerName)` The name for the trigger.
`void` | `setUnit(String unit)` Constraints: Pattern: (Seconds|Bytes|Bits|Percent|Count|Bytes/Second|Bits/Second|Count/Second|None)
`void` | `setUpperBreachScaleIncrement(String upperBreachScaleIncrement)` The incremental amount to use when performing scaling activities after the upper threshold has been breached.
`void` | `setUpperThreshold(Double upperThreshold)` The upper limit for the metric.
`String` | `toString()` Returns a string representation of this object; useful for testing and debugging.
`CreateOrUpdateScalingTriggerRequest` | `withAutoScalingGroupName(String autoScalingGroupName)` The name of the AutoScalingGroup to be associated with the trigger.
`CreateOrUpdateScalingTriggerRequest` | `withBreachDuration(Integer breachDuration)` The amount of time, in seconds, used to evaluate and determine if a breach is occurring.
`CreateOrUpdateScalingTriggerRequest` | `withCustomUnit(String customUnit)` The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.
`CreateOrUpdateScalingTriggerRequest` | `withDimensions(Collection<Dimension> dimensions)` A list of dimensions associated with the metric used by the trigger to determine whether to fire.
`CreateOrUpdateScalingTriggerRequest` | `withDimensions(Dimension... dimensions)` A list of dimensions associated with the metric used by the trigger to determine whether to fire.
`CreateOrUpdateScalingTriggerRequest` | `withLowerBreachScaleIncrement(String lowerBreachScaleIncrement)` The incremental amount to use when performing scaling activities after the lower threshold has been breached.
`CreateOrUpdateScalingTriggerRequest` | `withLowerThreshold(Double lowerThreshold)` The lower limit for the metric.
`CreateOrUpdateScalingTriggerRequest` | `withMeasureName(String measureName)` The measure name associated with the metric used by the trigger to determine when to fire.
`CreateOrUpdateScalingTriggerRequest` | `withNamespace(String namespace)` Returns a reference to this object so that method calls can be chained together.
`CreateOrUpdateScalingTriggerRequest` | `withPeriod(Integer period)` The period, in seconds, associated witht he metric statistics.
`CreateOrUpdateScalingTriggerRequest` | `withStatistic(String statistic)` The statistic that the trigger when fetching metrics to examine.
`CreateOrUpdateScalingTriggerRequest` | `withTriggerName(String triggerName)` The name for the trigger.
`CreateOrUpdateScalingTriggerRequest` | `withUnit(String unit)` Returns a reference to this object so that method calls can be chained together.
`CreateOrUpdateScalingTriggerRequest` | `withUpperBreachScaleIncrement(String upperBreachScaleIncrement)` The incremental amount to use when performing scaling activities after the upper threshold has been breached.
`CreateOrUpdateScalingTriggerRequest` | `withUpperThreshold(Double upperThreshold)` The upper limit for the metric.

Methods inherited from class com.amazonaws.AmazonWebServiceRequest
`copyPrivateRequestParameters`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CreateOrUpdateScalingTriggerRequest

    public CreateOrUpdateScalingTriggerRequest()

Method Detail

### getTriggerName

    public String getTriggerName()

  The name for the trigger.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Returns:
    The name for the trigger.

### setTriggerName

    public void setTriggerName(String triggerName)

  The name for the trigger.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `triggerName` - The name for the trigger.

### withTriggerName

    public CreateOrUpdateScalingTriggerRequest withTriggerName(String triggerName)

  The name for the trigger.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `triggerName` - The name for the trigger.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getAutoScalingGroupName

    public String getAutoScalingGroupName()

  The name of the AutoScalingGroup to be associated with the trigger.

  Constraints:
  Length: 1 - 100
  Pattern: [ -??-??-?\r\n\t]*

  Returns:
    The name of the AutoScalingGroup to be associated with the trigger.

### setAutoScalingGroupName

    public void setAutoScalingGroupName(String autoScalingGroupName)

  The name of the AutoScalingGroup to be associated with the trigger.

  Constraints:
  Length: 1 - 100
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `autoScalingGroupName` - The name of the AutoScalingGroup to be associated with the trigger.

### withAutoScalingGroupName

    public CreateOrUpdateScalingTriggerRequest withAutoScalingGroupName(String autoScalingGroupName)

  The name of the AutoScalingGroup to be associated with the trigger.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 - 100
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `autoScalingGroupName` - The name of the AutoScalingGroup to be associated with the trigger.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getMeasureName

    public String getMeasureName()

  The measure name associated with the metric used by the trigger to determine when to fire. For more information, please see Amazon CloudWatch product documentation.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Returns:
    The measure name associated with the metric used by the trigger to determine when to fire. For more information, please see Amazon CloudWatch product documentation.

### setMeasureName

    public void setMeasureName(String measureName)

  The measure name associated with the metric used by the trigger to determine when to fire. For more information, please see Amazon CloudWatch product documentation.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `measureName` - The measure name associated with the metric used by the trigger to determine when to fire. For more information, please see Amazon CloudWatch product documentation.

### withMeasureName

    public CreateOrUpdateScalingTriggerRequest withMeasureName(String measureName)

  The measure name associated with the metric used by the trigger to determine when to fire. For more information, please see Amazon CloudWatch product documentation.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `measureName` - The measure name associated with the metric used by the trigger to determine when to fire. For more information, please see Amazon CloudWatch product documentation.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getStatistic

    public String getStatistic()

  The statistic that the trigger when fetching metrics to examine.

  Constraints:
  Pattern: (Average|Sum|Minimum|Maximum)

  Returns:
    The statistic that the trigger when fetching metrics to examine.

### setStatistic

    public void setStatistic(String statistic)

  The statistic that the trigger when fetching metrics to examine.

  Constraints:
  Pattern: (Average|Sum|Minimum|Maximum)

  Parameters:
    `statistic` - The statistic that the trigger when fetching metrics to examine.

### withStatistic

    public CreateOrUpdateScalingTriggerRequest withStatistic(String statistic)

  The statistic that the trigger when fetching metrics to examine.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Pattern: (Average|Sum|Minimum|Maximum)

  Parameters:
    `statistic` - The statistic that the trigger when fetching metrics to examine.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getDimensions

    public List<Dimension> getDimensions()

  A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.

  Constraints:
  Length: 1 -

  Returns:
    A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.

### setDimensions

    public void setDimensions(Collection<Dimension> dimensions)

  A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.

  Constraints:
  Length: 1 -

  Parameters:
    `dimensions` - A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.

### withDimensions

    public CreateOrUpdateScalingTriggerRequest withDimensions(Dimension... dimensions)

  A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 -

  Parameters:
    `dimensions` - A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### withDimensions

    public CreateOrUpdateScalingTriggerRequest withDimensions(Collection<Dimension> dimensions)

  A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 -

  Parameters:
    `dimensions` - A list of dimensions associated with the metric used by the trigger to determine whether to fire. For more information, please see Amazon CloudWatch product documentation.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getPeriod

    public Integer getPeriod()

  The period, in seconds, associated witht he metric statistics.

  Returns:
    The period, in seconds, associated witht he metric statistics.

### setPeriod

    public void setPeriod(Integer period)

  The period, in seconds, associated witht he metric statistics.

  Parameters:
    `period` - The period, in seconds, associated witht he metric statistics.

### withPeriod

    public CreateOrUpdateScalingTriggerRequest withPeriod(Integer period)

  The period, in seconds, associated witht he metric statistics.

  Returns a reference to this object so that method calls can be chained together.

  Parameters:
    `period` - The period, in seconds, associated witht he metric statistics.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getUnit

    public String getUnit()

  Constraints:
  Pattern: (Seconds|Bytes|Bits|Percent|Count|Bytes/Second|Bits/Second|Count/Second|None)

  Returns:

### setUnit

    public void setUnit(String unit)

  Constraints:
  Pattern: (Seconds|Bytes|Bits|Percent|Count|Bytes/Second|Bits/Second|Count/Second|None)

  Parameters:
    `unit` -

### withUnit

    public CreateOrUpdateScalingTriggerRequest withUnit(String unit)

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Pattern: (Seconds|Bytes|Bits|Percent|Count|Bytes/Second|Bits/Second|Count/Second|None)

  Parameters:
    `unit` -
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getCustomUnit

    public String getCustomUnit()

  The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.

  Constraints:
  Pattern: [ -??-??-?\r\n\t]*

  Returns:
    The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.

### setCustomUnit

    public void setCustomUnit(String customUnit)

  The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.

  Constraints:
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `customUnit` - The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.

### withCustomUnit

    public CreateOrUpdateScalingTriggerRequest withCustomUnit(String customUnit)

  The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `customUnit` - The standard unit of measurement for a given measure that the trigger uses when fetching metrics to examine.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getNamespace

    public String getNamespace()

  Constraints:
  Length: 1 - 100
  Pattern: [ -9;-??-??-?\r\n\t]*

  Returns:

### setNamespace

    public void setNamespace(String namespace)

  Constraints:
  Length: 1 - 100
  Pattern: [ -9;-??-??-?\r\n\t]*

  Parameters:
    `namespace` -

### withNamespace

    public CreateOrUpdateScalingTriggerRequest withNamespace(String namespace)

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 - 100
  Pattern: [ -9;-??-??-?\r\n\t]*

  Parameters:
    `namespace` -
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getLowerThreshold

    public Double getLowerThreshold()

  The lower limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

  Returns:
    The lower limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

### setLowerThreshold

    public void setLowerThreshold(Double lowerThreshold)

  The lower limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

  Parameters:
    `lowerThreshold` - The lower limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

### withLowerThreshold

    public CreateOrUpdateScalingTriggerRequest withLowerThreshold(Double lowerThreshold)

  The lower limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

  Returns a reference to this object so that method calls can be chained together.

  Parameters:
    `lowerThreshold` - The lower limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getLowerBreachScaleIncrement

    public String getLowerBreachScaleIncrement()

  The incremental amount to use when performing scaling activities after the lower threshold has been breached.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Returns:
    The incremental amount to use when performing scaling activities after the lower threshold has been breached.

### setLowerBreachScaleIncrement

    public void setLowerBreachScaleIncrement(String lowerBreachScaleIncrement)

  The incremental amount to use when performing scaling activities after the lower threshold has been breached.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `lowerBreachScaleIncrement` - The incremental amount to use when performing scaling activities after the lower threshold has been breached.

### withLowerBreachScaleIncrement

    public CreateOrUpdateScalingTriggerRequest withLowerBreachScaleIncrement(String lowerBreachScaleIncrement)

  The incremental amount to use when performing scaling activities after the lower threshold has been breached.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `lowerBreachScaleIncrement` - The incremental amount to use when performing scaling activities after the lower threshold has been breached.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getUpperThreshold

    public Double getUpperThreshold()

  The upper limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

  Returns:
    The upper limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

### setUpperThreshold

    public void setUpperThreshold(Double upperThreshold)

  The upper limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

  Parameters:
    `upperThreshold` - The upper limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

### withUpperThreshold

    public CreateOrUpdateScalingTriggerRequest withUpperThreshold(Double upperThreshold)

  The upper limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.

  Returns a reference to this object so that method calls can be chained together.

  Parameters:
    `upperThreshold` - The upper limit for the metric. If all data points in the last BreachDuration seconds fall below the lower threshold or exceed the upper threshold, the trigger activates.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getUpperBreachScaleIncrement

    public String getUpperBreachScaleIncrement()

  The incremental amount to use when performing scaling activities after the upper threshold has been breached. If only a positive or negative number is specified, then the AutoScaling group will increase or decrease by the specified number of actual instances. If positive or negative number followed by a percent sign is specified, the AutoScaling group will increase or decrease as a percentage.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Returns:
    The incremental amount to use when performing scaling activities after the upper threshold has been breached. If only a positive or negative number is specified, then the AutoScaling group will increase or decrease by the specified number of actual instances. If positive or negative number followed by a percent sign is specified, the AutoScaling group will increase or decrease as a percentage.

### setUpperBreachScaleIncrement

    public void setUpperBreachScaleIncrement(String upperBreachScaleIncrement)

  The incremental amount to use when performing scaling activities after the upper threshold has been breached. If only a positive or negative number is specified, then the AutoScaling group will increase or decrease by the specified number of actual instances. If positive or negative number followed by a percent sign is specified, the AutoScaling group will increase or decrease as a percentage.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `upperBreachScaleIncrement` - The incremental amount to use when performing scaling activities after the upper threshold has been breached. If only a positive or negative number is specified, then the AutoScaling group will increase or decrease by the specified number of actual instances. If positive or negative number followed by a percent sign is specified, the AutoScaling group will increase or decrease as a percentage.

### withUpperBreachScaleIncrement

    public CreateOrUpdateScalingTriggerRequest withUpperBreachScaleIncrement(String upperBreachScaleIncrement)

  The incremental amount to use when performing scaling activities after the upper threshold has been breached. If only a positive or negative number is specified, then the AutoScaling group will increase or decrease by the specified number of actual instances. If positive or negative number followed by a percent sign is specified, the AutoScaling group will increase or decrease as a percentage.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Length: 1 - 255
  Pattern: [ -??-??-?\r\n\t]*

  Parameters:
    `upperBreachScaleIncrement` - The incremental amount to use when performing scaling activities after the upper threshold has been breached. If only a positive or negative number is specified, then the AutoScaling group will increase or decrease by the specified number of actual instances. If positive or negative number followed by a percent sign is specified, the AutoScaling group will increase or decrease as a percentage.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### getBreachDuration

    public Integer getBreachDuration()

  The amount of time, in seconds, used to evaluate and determine if a breach is occurring. The service will look at data between the current time and the number of seconds specified in this parameter to see if a breach has occurred.

  Constraints:
  Range: 120 - 86400

  Returns:
    The amount of time, in seconds, used to evaluate and determine if a breach is occurring. The service will look at data between the current time and the number of seconds specified in this parameter to see if a breach has occurred.

### setBreachDuration

    public void setBreachDuration(Integer breachDuration)

  The amount of time, in seconds, used to evaluate and determine if a breach is occurring. The service will look at data between the current time and the number of seconds specified in this parameter to see if a breach has occurred.

  Constraints:
  Range: 120 - 86400

  Parameters:
    `breachDuration` - The amount of time, in seconds, used to evaluate and determine if a breach is occurring. The service will look at data between the current time and the number of seconds specified in this parameter to see if a breach has occurred.

### withBreachDuration

    public CreateOrUpdateScalingTriggerRequest withBreachDuration(Integer breachDuration)

  The amount of time, in seconds, used to evaluate and determine if a breach is occurring. The service will look at data between the current time and the number of seconds specified in this parameter to see if a breach has occurred.

  Returns a reference to this object so that method calls can be chained together.

  Constraints:
  Range: 120 - 86400

  Parameters:
    `breachDuration` - The amount of time, in seconds, used to evaluate and determine if a breach is occurring. The service will look at data between the current time and the number of seconds specified in this parameter to see if a breach has occurred.
  Returns:
    A reference to this updated object so that method calls can be chained together.

### toString

    public String toString()

  Returns a string representation of this object; useful for testing and debugging.

  Overrides:
    `toString` in class `Object`
  Returns:
    A string representation of this object.
  See Also:
    `Object.toString()`

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.